This documentation is automatically generated by online-judge-tools/verification-helper
View the Project on GitHub maspypy/library
#define PROBLEM "https://judge.yosupo.jp/problem/aplusb" #include "my_template.hpp" #include "random/base.hpp" #include "geo/range_closest_pair_query.hpp" void test() { FOR(N, 2, 100) { FOR(Q, 1, 100) { vc<pair<int, int>> point(N), query(Q); FOR(i, N) { int x = RNG(0, 20); int y = RNG(0, 20); point[i] = {x, y}; } FOR(q, Q) { while (1) { int L = RNG(0, N); int R = RNG(0, N); if (L + 1 <= R) { query[q] = {L, R + 1}; break; } } } Range_Closest_Pair_Query X; for (auto&& [a, b]: point) X.add_point(a, b); for (auto&& [l, r]: query) X.add_query(l, r); vi ANS = X.calc(); FOR(q, Q) { ll ans = infty<ll>; auto [L, R] = query[q]; FOR(i, L, R) FOR(j, L, R) { if (i == j) continue; auto [x1, y1] = point[i]; auto [x2, y2] = point[j]; ll dx = x1 - x2, dy = y1 - y2; chmin(ans, dx * dx + dy * dy); } assert(ans == ANS[q]); } } } } void solve() { int a, b; cin >> a >> b; cout << a + b << "\n"; } signed main() { test(); solve(); return 0; }
#line 1 "test/1_mytest/range_closest_pair.test.cpp" #define PROBLEM "https://judge.yosupo.jp/problem/aplusb" #line 1 "my_template.hpp" #if defined(LOCAL) #include <my_template_compiled.hpp> #else // https://codeforces.com/blog/entry/96344 #pragma GCC optimize("Ofast,unroll-loops") // いまの CF だとこれ入れると動かない? // #pragma GCC target("avx2,popcnt") #include <bits/stdc++.h> using namespace std; using ll = long long; using u8 = uint8_t; using u16 = uint16_t; using u32 = uint32_t; using u64 = uint64_t; using i128 = __int128; using u128 = unsigned __int128; using f128 = __float128; template <class T> constexpr T infty = 0; template <> constexpr int infty<int> = 1'010'000'000; template <> constexpr ll infty<ll> = 2'020'000'000'000'000'000; template <> constexpr u32 infty<u32> = infty<int>; template <> constexpr u64 infty<u64> = infty<ll>; template <> constexpr i128 infty<i128> = i128(infty<ll>) * 2'000'000'000'000'000'000; template <> constexpr double infty<double> = infty<ll>; template <> constexpr long double infty<long double> = infty<ll>; using pi = pair<ll, ll>; using vi = vector<ll>; template <class T> using vc = vector<T>; template <class T> using vvc = vector<vc<T>>; template <class T> using vvvc = vector<vvc<T>>; template <class T> using vvvvc = vector<vvvc<T>>; template <class T> using vvvvvc = vector<vvvvc<T>>; template <class T> using pq = priority_queue<T>; template <class T> using pqg = priority_queue<T, vector<T>, greater<T>>; #define vv(type, name, h, ...) vector<vector<type>> name(h, vector<type>(__VA_ARGS__)) #define vvv(type, name, h, w, ...) vector<vector<vector<type>>> name(h, vector<vector<type>>(w, vector<type>(__VA_ARGS__))) #define vvvv(type, name, a, b, c, ...) \ vector<vector<vector<vector<type>>>> name(a, vector<vector<vector<type>>>(b, vector<vector<type>>(c, vector<type>(__VA_ARGS__)))) // https://trap.jp/post/1224/ #define FOR1(a) for (ll _ = 0; _ < ll(a); ++_) #define FOR2(i, a) for (ll i = 0; i < ll(a); ++i) #define FOR3(i, a, b) for (ll i = a; i < ll(b); ++i) #define FOR4(i, a, b, c) for (ll i = a; i < ll(b); i += (c)) #define FOR1_R(a) for (ll i = (a)-1; i >= ll(0); --i) #define FOR2_R(i, a) for (ll i = (a)-1; i >= ll(0); --i) #define FOR3_R(i, a, b) for (ll i = (b)-1; i >= ll(a); --i) #define overload4(a, b, c, d, e, ...) e #define overload3(a, b, c, d, ...) d #define FOR(...) overload4(__VA_ARGS__, FOR4, FOR3, FOR2, FOR1)(__VA_ARGS__) #define FOR_R(...) overload3(__VA_ARGS__, FOR3_R, FOR2_R, FOR1_R)(__VA_ARGS__) #define FOR_subset(t, s) for (ll t = (s); t >= 0; t = (t == 0 ? -1 : (t - 1) & (s))) #define all(x) x.begin(), x.end() #define len(x) ll(x.size()) #define elif else if #define eb emplace_back #define mp make_pair #define mt make_tuple #define fi first #define se second #define stoi stoll int popcnt(int x) { return __builtin_popcount(x); } int popcnt(u32 x) { return __builtin_popcount(x); } int popcnt(ll x) { return __builtin_popcountll(x); } int popcnt(u64 x) { return __builtin_popcountll(x); } int popcnt_mod_2(int x) { return __builtin_parity(x); } int popcnt_mod_2(u32 x) { return __builtin_parity(x); } int popcnt_mod_2(ll x) { return __builtin_parityll(x); } int popcnt_mod_2(u64 x) { return __builtin_parityll(x); } // (0, 1, 2, 3, 4) -> (-1, 0, 1, 1, 2) int topbit(int x) { return (x == 0 ? -1 : 31 - __builtin_clz(x)); } int topbit(u32 x) { return (x == 0 ? -1 : 31 - __builtin_clz(x)); } int topbit(ll x) { return (x == 0 ? -1 : 63 - __builtin_clzll(x)); } int topbit(u64 x) { return (x == 0 ? -1 : 63 - __builtin_clzll(x)); } // (0, 1, 2, 3, 4) -> (-1, 0, 1, 0, 2) int lowbit(int x) { return (x == 0 ? -1 : __builtin_ctz(x)); } int lowbit(u32 x) { return (x == 0 ? -1 : __builtin_ctz(x)); } int lowbit(ll x) { return (x == 0 ? -1 : __builtin_ctzll(x)); } int lowbit(u64 x) { return (x == 0 ? -1 : __builtin_ctzll(x)); } template <typename T> T floor(T a, T b) { return a / b - (a % b && (a ^ b) < 0); } template <typename T> T ceil(T x, T y) { return floor(x + y - 1, y); } template <typename T> T bmod(T x, T y) { return x - y * floor(x, y); } template <typename T> pair<T, T> divmod(T x, T y) { T q = floor(x, y); return {q, x - q * y}; } template <typename T, typename U> T SUM(const vector<U> &A) { T sm = 0; for (auto &&a: A) sm += a; return sm; } #define MIN(v) *min_element(all(v)) #define MAX(v) *max_element(all(v)) #define LB(c, x) distance((c).begin(), lower_bound(all(c), (x))) #define UB(c, x) distance((c).begin(), upper_bound(all(c), (x))) #define UNIQUE(x) sort(all(x)), x.erase(unique(all(x)), x.end()), x.shrink_to_fit() template <typename T> T POP(deque<T> &que) { T a = que.front(); que.pop_front(); return a; } template <typename T> T POP(pq<T> &que) { T a = que.top(); que.pop(); return a; } template <typename T> T POP(pqg<T> &que) { T a = que.top(); que.pop(); return a; } template <typename T> T POP(vc<T> &que) { T a = que.back(); que.pop_back(); return a; } template <typename F> ll binary_search(F check, ll ok, ll ng, bool check_ok = true) { if (check_ok) assert(check(ok)); while (abs(ok - ng) > 1) { auto x = (ng + ok) / 2; (check(x) ? ok : ng) = x; } return ok; } template <typename F> double binary_search_real(F check, double ok, double ng, int iter = 100) { FOR(iter) { double x = (ok + ng) / 2; (check(x) ? ok : ng) = x; } return (ok + ng) / 2; } template <class T, class S> inline bool chmax(T &a, const S &b) { return (a < b ? a = b, 1 : 0); } template <class T, class S> inline bool chmin(T &a, const S &b) { return (a > b ? a = b, 1 : 0); } // ? は -1 vc<int> s_to_vi(const string &S, char first_char) { vc<int> A(S.size()); FOR(i, S.size()) { A[i] = (S[i] != '?' ? S[i] - first_char : -1); } return A; } template <typename T, typename U> vector<T> cumsum(vector<U> &A, int off = 1) { int N = A.size(); vector<T> B(N + 1); FOR(i, N) { B[i + 1] = B[i] + A[i]; } if (off == 0) B.erase(B.begin()); return B; } // stable sort template <typename T> vector<int> argsort(const vector<T> &A) { vector<int> ids(len(A)); iota(all(ids), 0); sort(all(ids), [&](int i, int j) { return (A[i] == A[j] ? i < j : A[i] < A[j]); }); return ids; } // A[I[0]], A[I[1]], ... template <typename T> vc<T> rearrange(const vc<T> &A, const vc<int> &I) { vc<T> B(len(I)); FOR(i, len(I)) B[i] = A[I[i]]; return B; } template <typename T, typename... Vectors> void concat(vc<T> &first, const Vectors &... others) { vc<T> &res = first; (res.insert(res.end(), others.begin(), others.end()), ...); } #endif #line 2 "random/base.hpp" u64 RNG_64() { static uint64_t x_ = uint64_t(chrono::duration_cast<chrono::nanoseconds>(chrono::high_resolution_clock::now().time_since_epoch()).count()) * 10150724397891781847ULL; x_ ^= x_ << 7; return x_ ^= x_ >> 9; } u64 RNG(u64 lim) { return RNG_64() % lim; } ll RNG(ll l, ll r) { return l + RNG_64() % (r - l); } #line 2 "ds/hashmap.hpp" // u64 -> Val template <typename Val> struct HashMap { // n は入れたいものの個数で ok HashMap(u32 n = 0) { build(n); } void build(u32 n) { u32 k = 8; while (k < n * 2) k *= 2; cap = k / 2, mask = k - 1; key.resize(k), val.resize(k), used.assign(k, 0); } // size を保ったまま. size=0 にするときは build すること. void clear() { used.assign(len(used), 0); cap = (mask + 1) / 2; } int size() { return len(used) / 2 - cap; } int index(const u64& k) { int i = 0; for (i = hash(k); used[i] && key[i] != k; i = (i + 1) & mask) {} return i; } Val& operator[](const u64& k) { if (cap == 0) extend(); int i = index(k); if (!used[i]) { used[i] = 1, key[i] = k, val[i] = Val{}, --cap; } return val[i]; } Val get(const u64& k, Val default_value) { int i = index(k); return (used[i] ? val[i] : default_value); } bool count(const u64& k) { int i = index(k); return used[i] && key[i] == k; } // f(key, val) template <typename F> void enumerate_all(F f) { FOR(i, len(used)) if (used[i]) f(key[i], val[i]); } private: u32 cap, mask; vc<u64> key; vc<Val> val; vc<bool> used; u64 hash(u64 x) { static const u64 FIXED_RANDOM = std::chrono::steady_clock::now().time_since_epoch().count(); x += FIXED_RANDOM; x = (x ^ (x >> 30)) * 0xbf58476d1ce4e5b9; x = (x ^ (x >> 27)) * 0x94d049bb133111eb; return (x ^ (x >> 31)) & mask; } void extend() { vc<pair<u64, Val>> dat; dat.reserve(len(used) / 2 - cap); FOR(i, len(used)) { if (used[i]) dat.eb(key[i], val[i]); } build(2 * len(dat)); for (auto& [a, b]: dat) (*this)[a] = b; } }; #line 2 "ds/segtree/dual_segtree.hpp" template <typename Monoid> struct Dual_SegTree { using MA = Monoid; using A = typename MA::value_type; int n, log, size; vc<A> laz; Dual_SegTree() : Dual_SegTree(0) {} Dual_SegTree(int n) { build(n); } void build(int m) { n = m; log = 1; while ((1 << log) < n) ++log; size = 1 << log; laz.assign(size << 1, MA::unit()); } A get(int p) { assert(0 <= p && p < n); p += size; for (int i = log; i >= 1; i--) push(p >> i); return laz[p]; } vc<A> get_all() { FOR(i, size) push(i); return {laz.begin() + size, laz.begin() + size + n}; } void set(int p, A x) { get(p); laz[p + size] = x; } void apply(int l, int r, const A& a) { assert(0 <= l && l <= r && r <= n); if (l == r) return; l += size, r += size; if (!MA::commute) { for (int i = log; i >= 1; i--) { if (((l >> i) << i) != l) push(l >> i); if (((r >> i) << i) != r) push((r - 1) >> i); } } while (l < r) { if (l & 1) all_apply(l++, a); if (r & 1) all_apply(--r, a); l >>= 1, r >>= 1; } } private: void push(int k) { if (laz[k] == MA::unit()) return; all_apply(2 * k, laz[k]), all_apply(2 * k + 1, laz[k]); laz[k] = MA::unit(); } void all_apply(int k, A a) { laz[k] = MA::op(laz[k], a); } }; #line 2 "alg/monoid/min.hpp" template <typename E> struct Monoid_Min { using X = E; using value_type = X; static constexpr X op(const X &x, const X &y) noexcept { return min(x, y); } static constexpr X unit() { return infty<E>; } static constexpr bool commute = true; }; #line 4 "geo/range_closest_pair_query.hpp" // 点群 {p_i | i in [l, r)} に対する最近点対の計算を行うクエリ // O(KNlogKN + QlogN) // https://qoj.ac/problem/5463 // https://codeforces.com/gym/104172/attachments/download/18933/Hong_Kong_Tutorial.pdf // 点群が 1 次元:https://codeforces.com/problemset/problem/765/F struct Range_Closest_Pair_Query { /* ・R を増やしながら、L ごとの答を管理する ・2^{k-1} <= ANS[L:R] < 2^{k} となる L :レベル k (レベル 0:距離 0) ・レベル 0, 1, 2, ..., 29 のグリッドを用意する ・幅は 2^k ・一辺 1.99 の正方形内で点対距離が 1 以上 → 8 個までありうる ・レベル 29, 28, ..., 0 の順に探索する:9 近傍 ・答が見つかったらレベルを下げる。左向きに伝搬。 ・レベルの減少は 30N 回までしか起きない */ const int LOG = 30; vc<pair<int, int>> point; vc<pair<int, int>> query; void add_point(int x, int y) { assert(0 <= x && x < (1 << LOG)); assert(0 <= y && y < (1 << LOG)); point.eb(x, y); } void add_query(int L, int R) { assert(R - L >= 2); query.eb(L, R); } ll dist(int i, int j) { ll dx = point[i].fi - point[j].fi; ll dy = point[i].se - point[j].se; return dx * dx + dy * dy; } vc<ll> calc() { const int K = LOG; const int N = len(point), Q = len(query); using A9 = array<int, 9>; // それぞれのレベルのときのセル番号 vv(int, IDX, K, N, -1); // 各セル番号に対する近傍 vc<A9> nbd; FOR(k, 1, K) { HashMap<int> MP(N); auto to_64 = [&](int x, int y) -> u64 { return u64(x) << 30 | y; }; int off = len(nbd); int p = off; FOR(i, N) { int x = point[i].fi >> (k); int y = point[i].se >> (k); u64 key = to_64(x, y); if (!MP.count(key)) { MP[key] = p++; } IDX[k][i] = MP[key]; } nbd.resize(p); FOR(i, N) { int x = point[i].fi >> (k); int y = point[i].se >> (k); int me = MP[to_64(x, y)]; int s = 0; FOR(dx, -1, 2) FOR(dy, -1, 2) { u64 key = to_64(x + dx, y + dy); nbd[me][s++] = MP.get(key, -1); } } } vc<array<int, 8>> dat(len(nbd), {-1, -1, -1, -1, -1, -1, -1, -1}); auto add = [&](int k, int i) -> void { int idx = IDX[k][i]; for (auto&& j: dat[idx]) { if (j == -1) { j = i; return; } } }; auto rm = [&](int k, int i) -> void { int idx = IDX[k][i]; for (auto&& j: dat[idx]) { if (j == i) { j = -1; return; } } }; auto solve_level = [&](int k, int i) -> vc<pair<int, ll>> { // レベル k の点群に対する答の計算 vc<pair<int, ll>> res; int me = IDX[k][i]; for (auto&& idx: nbd[me]) { if (idx == -1) continue; for (auto&& j: dat[idx]) { if (j == -1) continue; res.eb(j, dist(i, j)); } } return res; }; Dual_SegTree<Monoid_Min<ll>> seg(N); vc<int> LEVEL(N, -1); auto get_lv = [&](ll d) -> int { if (d == 0) return 0; return topbit(d) / 2 + 1; }; vc<int> left(Q); vvc<int> query_at(N); FOR(qid, Q) { auto [L, R] = query[qid]; left[qid] = L; query_at[--R].eb(qid); } vi ANS(Q); FOR(R, N) { // R 番目の点を用いた答の更新 vc<pair<int, ll>> upd; FOR(k, 1, K) { auto res = solve_level(k, R); upd.insert(upd.end(), all(res)); } for (auto [i, d]: upd) { int lv = get_lv(d); if (seg.get(i) < d) continue; // 答えの更新 seg.apply(0, i + 1, d); // レベルの更新 while (i >= 0 && LEVEL[i] > lv) { rm(LEVEL[i], i); LEVEL[i] = lv; if (lv) add(lv, i); --i; } } LEVEL[R] = K - 1; add(K - 1, R); for (auto&& qid: query_at[R]) { ANS[qid] = seg.get(left[qid]); } } return ANS; } }; #line 5 "test/1_mytest/range_closest_pair.test.cpp" void test() { FOR(N, 2, 100) { FOR(Q, 1, 100) { vc<pair<int, int>> point(N), query(Q); FOR(i, N) { int x = RNG(0, 20); int y = RNG(0, 20); point[i] = {x, y}; } FOR(q, Q) { while (1) { int L = RNG(0, N); int R = RNG(0, N); if (L + 1 <= R) { query[q] = {L, R + 1}; break; } } } Range_Closest_Pair_Query X; for (auto&& [a, b]: point) X.add_point(a, b); for (auto&& [l, r]: query) X.add_query(l, r); vi ANS = X.calc(); FOR(q, Q) { ll ans = infty<ll>; auto [L, R] = query[q]; FOR(i, L, R) FOR(j, L, R) { if (i == j) continue; auto [x1, y1] = point[i]; auto [x2, y2] = point[j]; ll dx = x1 - x2, dy = y1 - y2; chmin(ans, dx * dx + dy * dy); } assert(ans == ANS[q]); } } } } void solve() { int a, b; cin >> a >> b; cout << a + b << "\n"; } signed main() { test(); solve(); return 0; }